summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
-rw-r--r--ChangeLog16
-rw-r--r--NEWS5
-rw-r--r--src/cp.c5
-rw-r--r--src/mv.c6
-rw-r--r--tests/cp/Makefile.am2
-rw-r--r--tests/cp/trailing-slash2
-rwxr-xr-xtests/mv/trailing-slash33
7 files changed, 55 insertions, 14 deletions
diff --git a/ChangeLog b/ChangeLog
index 591d4c03d..66bfa4dde 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,5 +1,21 @@
2006-09-08 Jim Meyering <jim@meyering.net>
+ mv and "cp -r" no longer fail when invoked with two arguments
+ where the first one names a directory and the second name ends in
+ a slash and doesn't exist. E.g., "mv dir B/", for nonexistent B,
+ now succeeds, once more. This reverts part of the 2004-06-27
+ change for 5.3.0.
+ * NEWS: Say the above.
+ * src/mv.c (target_directory_operand): Don't require (here)
+ that the target operand "look like" a directory. This change
+ pushes the test down to the rename syscall level, where a
+ "mv dir existing-non-dir/" will mistakenly succeed on older systems
+ that ignore trailing slashes in the rename destination argument.
+ * src/cp.c (target_directory_operand): Likewise, but for cp.
+ * tests/mv/trailing-slash: Exercise the above fixes.
+ * tests/cp/trailing-slash: New file.
+ * tests/cp/Makefile.am (EXTRA_DIST): Add trailing-slash.
+
* bootstrap: Use the previously unused variable, $src,
to avoid repeating "$GNULIB_SRCDIR/$file".
diff --git a/NEWS b/NEWS
index 93308ef1b..ffe7fcb05 100644
--- a/NEWS
+++ b/NEWS
@@ -27,6 +27,11 @@ GNU coreutils NEWS -*- outline -*-
"mv -T --verbose --backup=t A B" now prints the " (backup: B.~1~)"
suffix when A and B are directories as well as when they are not.
+ mv and "cp -r" no longer fail when invoked with two arguments
+ where the first one names a directory and the second name ends in
+ a slash and doesn't exist. E.g., "mv dir B/", for nonexistent B,
+ now succeeds, once more. This bug was introduced in coreutils-5.3.0.
+
* Major changes in release 6.1 (2006-08-19) [unstable]
diff --git a/src/cp.c b/src/cp.c
index 8ef115373..679ef0fe7 100644
--- a/src/cp.c
+++ b/src/cp.c
@@ -518,9 +518,6 @@ make_dir_parents_private (char const *const_dir, size_t src_offset,
static bool
target_directory_operand (char const *file, struct stat *st, bool *new_dst)
{
- char const *b = last_component (file);
- size_t blen = strlen (b);
- bool looks_like_a_dir = (blen == 0 || ISSLASH (b[blen - 1]));
int err = (stat (file, st) == 0 ? 0 : errno);
bool is_a_dir = !err && S_ISDIR (st->st_mode);
if (err)
@@ -529,8 +526,6 @@ target_directory_operand (char const *file, struct stat *st, bool *new_dst)
error (EXIT_FAILURE, err, _("accessing %s"), quote (file));
*new_dst = true;
}
- if (is_a_dir < looks_like_a_dir)
- error (EXIT_FAILURE, err, _("target %s is not a directory"), quote (file));
return is_a_dir;
}
diff --git a/src/mv.c b/src/mv.c
index e32cbcc97..ffc86d186 100644
--- a/src/mv.c
+++ b/src/mv.c
@@ -147,16 +147,11 @@ cp_option_init (struct cp_options *x)
static bool
target_directory_operand (char const *file)
{
- char const *b = last_component (file);
- size_t blen = strlen (b);
- bool looks_like_a_dir = (blen == 0 || ISSLASH (b[blen - 1]));
struct stat st;
int err = (stat (file, &st) == 0 ? 0 : errno);
bool is_a_dir = !err && S_ISDIR (st.st_mode);
if (err && err != ENOENT)
error (EXIT_FAILURE, err, _("accessing %s"), quote (file));
- if (is_a_dir < looks_like_a_dir)
- error (EXIT_FAILURE, err, _("target %s is not a directory"), quote (file));
return is_a_dir;
}
@@ -258,7 +253,6 @@ movefile (char *source, char *dest, bool dest_is_dir,
function that ignores a trailing slash. I believe the Linux
rename semantics are POSIX and susv2 compliant. */
- strip_trailing_slashes (dest);
if (remove_trailing_slashes)
strip_trailing_slashes (source);
diff --git a/tests/cp/Makefile.am b/tests/cp/Makefile.am
index a96eab7ae..0b42f3a8a 100644
--- a/tests/cp/Makefile.am
+++ b/tests/cp/Makefile.am
@@ -31,7 +31,7 @@ TESTS = \
same-file cp-mv-backup symlink-slash slink-2-slink fail-perm dir-slash \
perm cp-HL special-bits link dir-rm-dest cp-parents deref-slink \
dir-vs-file into-self
-EXTRA_DIST = $(TESTS)
+EXTRA_DIST = $(TESTS) trailing-slash
TESTS_ENVIRONMENT = \
MAKE=$(MAKE) \
CONFIG_HEADER=$(CONFIG_HEADER) \
diff --git a/tests/cp/trailing-slash b/tests/cp/trailing-slash
new file mode 100644
index 000000000..0cdbfa7b5
--- /dev/null
+++ b/tests/cp/trailing-slash
@@ -0,0 +1,2 @@
+# this is just a place-holder.
+# For trailing-slash-related tests, see ../mv/trailing-slash.
diff --git a/tests/mv/trailing-slash b/tests/mv/trailing-slash
index 19343b122..96201cf12 100755
--- a/tests/mv/trailing-slash
+++ b/tests/mv/trailing-slash
@@ -1,8 +1,10 @@
#!/bin/sh
# On some operating systems, e.g. SunOS-4.1.1_U1 on sun3x,
# rename() doesn't accept trailing slashes.
+# Also, ensure that "mv dir non-exist-dir/" works.
+# Also, ensure that "cp dir non-exist-dir/" works.
-# Copyright (C) 2004 Free Software Foundation, Inc.
+# Copyright (C) 2004, 2006 Free Software Foundation, Inc.
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
@@ -37,7 +39,7 @@ cd $tmp || framework_failure=1
mkdir foo || framework_failure=1
if test $framework_failure = 1; then
- echo 'failure in testing framework'
+ echo 'failure in testing framework' 1>&2
exit 1
fi
@@ -45,4 +47,31 @@ fail=0
mv foo/ bar || fail=1
+# mv and cp would misbehave for coreutils versions [5.3.0..5.97], 6.0 and 6.1
+for cmd in mv 'cp -r'; do
+ for opt in '' -T -u; do
+ rm -rf d e || framework_failure=1
+ mkdir d || framework_failure=1
+ if test $framework_failure = 1; then
+ echo 'failure in testing framework'
+ (exit 1); exit 1
+ fi
+
+ $cmd $opt d e/ || fail=1
+ if test "$cmd" = mv; then
+ test -d d && fail=1
+ else
+ test -d d || fail=1
+ fi
+ test -d e || fail=1
+ done
+done
+
+# We would like the erroneous-looking "mv any non-dir/" to fail,
+# but with the current implementation, it depends on how the
+# underlying rename syscall handles the trailing slash.
+# It does fail, as desired, on recent Linux and Solaris systems.
+#touch a a2
+#mv a a2/ && fail=1
+
(exit $fail); exit $fail